package com.hzya.frame.plugin.oa.praybill.service.impl;

import cn.hutool.core.util.StrUtil;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.hzya.frame.basedao.service.impl.BaseService;
import com.hzya.frame.plugin.oa.praybill.dao.IRequisitionOrderDao;
import com.hzya.frame.plugin.oa.praybill.entity.RequisitionOrderEntity;
import com.hzya.frame.plugin.oa.praybill.service.IRequisitionOrderService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Description OA请购单
 * @Author xiangerlin
 * @Date 2025/6/8 17:11
 **/
@Service(value = "requisitionOrderServiceImpl")
public class RequisitionOrderServiceImpl extends BaseService<RequisitionOrderEntity,String> implements IRequisitionOrderService {

    private IRequisitionOrderDao requisitionOrderDao;

    @Autowired
    public void setRequisitionOrderDao(IRequisitionOrderDao dao) {
        this.requisitionOrderDao = dao;
        this.dao = dao;
    }

    /**
     * 更新OA单据
     *
     * @param entity
     * @return
     */
    @DS(value = "#entity.dataSourceCode")
    @Override
    public int updateOrder(RequisitionOrderEntity entity) {
        if (null != entity && StrUtil.isNotEmpty(entity.getId())){
            requisitionOrderDao.update(entity);
        }
        return 0;
    }
}
