package com.hzya.frame.sys.flow.service;

import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.sys.flow.entity.SysFlowClassRuleEntity;
import com.hzya.frame.basedao.service.IBaseService;
import com.hzya.frame.web.entity.JsonResultEntity;

/**
 * 流程分类权限表(SysFlowClassRule)表服务接口
 *
 * @author xiang2lin
 * @since 2025-04-29 10:16:27
 */
public interface ISysFlowClassRuleService extends IBaseService<SysFlowClassRuleEntity, String>{

    /**
     * 新增流程分类权限
     * @param object
     * @return
     */
    JsonResultEntity saveFlowClassRule(JSONObject object);

    /**
     * 修改流程分类权限
     * @param object
     * @return
     */
    JsonResultEntity updateFlowClassRule(JSONObject object);

    /**
     * 删除流程分类权限
     * @param object
     * @return
     */
    JsonResultEntity deleteFlowClassRule(JSONObject object);

    /**
     * 列表查询
     * @param object
     * @return
     */
    JsonResultEntity queryRuleList(JSONObject object);

    /**
     * 分页查询
     * @param object
     * @return
     */
    JsonResultEntity queryRulePagedInfo(JSONObject object);

    /**
     * 查询待分配权限的用户列表
     * @param object
     * @return
     */
    JsonResultEntity queryUserList(JSONObject object);
}
