package com.hzya.frame.seeyon.org.member.service.impl;

import cn.hutool.core.util.StrUtil;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.hzya.frame.basedao.service.impl.BaseService;
import com.hzya.frame.seeyon.org.member.dao.IUserViewDao;
import com.hzya.frame.seeyon.org.member.entity.UserViewEntity;
import com.hzya.frame.seeyon.org.member.service.IUserViewService;
import com.hzya.frame.web.exception.BaseSystemException;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Description OA人员视图
 * @Author xiangerlin
 * @Date 2025/6/15 16:37
 **/
@Service(value = "userViewService")
public class UserViewServiceImpl extends BaseService<UserViewEntity,String> implements IUserViewService {

    private IUserViewDao userViewDao;

    @Autowired
    public void setUserViewDao(IUserViewDao dao) {
        this.userViewDao = dao;
        this.dao = dao;
    }

    /**
     * 查询全部 包含停用
     *
     * @param entity
     * @return
     */
    @DS(value = "#entity.dataSourceCode")
    @Override
    public List<UserViewEntity> queryAll(UserViewEntity entity) {
        List<UserViewEntity> queryList = userViewDao.query(entity);
        return queryList;
    }

    /**
     * 只查启用的
     *
     * @param entity
     * @return
     */
    @DS(value = "#entity.dataSourceCode")
    @Override
    public List<UserViewEntity> queryEnableList(UserViewEntity entity) {
        entity.setState("1");
        List<UserViewEntity> queryList = userViewDao.query(entity);
        return queryList;
    }

    /**
     * 根据人员编号查
     *
     * @param entity
     * @return
     */
    @DS(value = "#entity.dataSourceCode")
    @Override
    public UserViewEntity queryByStaffNumber(UserViewEntity entity) {
        if (null != entity && StrUtil.isNotEmpty(entity.getStaffNumber())){
            List<UserViewEntity> queryList = queryEnableList(entity);
            if (CollectionUtils.isNotEmpty(queryList)){
                if (queryList.size() > 1){
                    throw new BaseSystemException("根据"+entity.getStaffNumber()+"查询到多个人员,请检查");
                }
                return queryList.get(0);
            }
        }else {
            throw new BaseSystemException("人员编号不能为空，请检查");
        }
        return null;
    }
}
